# ``twisted`.`conch`.`ssh`.`transport``

module documentation
(source)

The lowest level SSH protocol. This handles the key negotiation, the encryption and the compression. The transport layer is described in RFC 4253.

Maintainer: Paul Swartz

Class | `SSHCiphers` | SSHCiphers represents all the encryption operations that need to occur to encrypt and authenticate the SSH connection.
Class | `SSHClientTransport` | SSHClientTransport implements the client side of the SSH protocol.
Class | `SSHServerTransport` | SSHServerTransport implements the server side of the SSH protocol.
Class | `SSHTransportBase` | Protocol supporting basic SSH functionality: sending/receiving packets and message dispatch. To connect to or run a server, you must use SSHClientTransport or SSHServerTransport.
Constant | `DH_GENERATOR` | Undocumented
Constant | `DH_PRIME` | Undocumented
Constant | `DISCONNECT_AUTH_CANCELLED_BY_USER` | Undocumented
Constant | `DISCONNECT_BY_APPLICATION` | Undocumented
Constant | `DISCONNECT_COMPRESSION_ERROR` | Undocumented
Constant | `DISCONNECT_CONNECTION_LOST` | Undocumented
Constant | `DISCONNECT_HOST_KEY_NOT_VERIFIABLE` | Undocumented
Constant | `DISCONNECT_HOST_NOT_ALLOWED_TO_CONNECT` | Undocumented
Constant | `DISCONNECT_ILLEGAL_USER_NAME` | Undocumented
Constant | `DISCONNECT_KEY_EXCHANGE_FAILED` | Undocumented
Constant | `DISCONNECT_MAC_ERROR` | Undocumented
Constant | `DISCONNECT_NO_MORE_AUTH_METHODS_AVAILABLE` | Undocumented
Constant | `DISCONNECT_PROTOCOL_ERROR` | Undocumented
Constant | `DISCONNECT_PROTOCOL_VERSION_NOT_SUPPORTED` | Undocumented
Constant | `DISCONNECT_RESERVED` | Undocumented
Constant | `DISCONNECT_SERVICE_NOT_AVAILABLE` | Undocumented
Constant | `DISCONNECT_TOO_MANY_CONNECTIONS` | Undocumented
Constant | `MSG_DEBUG` | Undocumented
Constant | `MSG_DISCONNECT` | Undocumented
Constant | `MSG_EXT_INFO` | Undocumented
Constant | `MSG_IGNORE` | Undocumented
Constant | `MSG_KEX_DH_GEX_GROUP` | Undocumented
Constant | `MSG_KEX_DH_GEX_INIT` | Undocumented
Constant | `MSG_KEX_DH_GEX_REPLY` | Undocumented
Constant | `MSG_KEX_DH_GEX_REQUEST` | Undocumented
Constant | `MSG_KEX_DH_GEX_REQUEST_OLD` | Undocumented
Constant | `MSG_KEXDH_INIT` | Undocumented
Constant | `MSG_KEXDH_REPLY` | Undocumented
Constant | `MSG_KEXINIT` | Undocumented
Constant | `MSG_NEWKEYS` | Undocumented
Constant | `MSG_SERVICE_ACCEPT` | Undocumented
Constant | `MSG_SERVICE_REQUEST` | Undocumented
Constant | `MSG_UNIMPLEMENTED` | Undocumented
Variable | `messages` | Undocumented
Class | `_DummyAlgorithm` | An encryption algorithm that does not actually encrypt anything.
Class | `_DummyCipher` | A cipher for the none encryption method.
Class | `_MACParams` | `_MACParams` represents the parameters necessary to compute SSH MAC (Message Authenticate Codes).
Class | `_NullEncryptionContext` | An encryption context that does not actually encrypt anything.
Function | `_getSupportedCiphers` | Build a list of ciphers that are supported by the backend in use.
Function | `_mpFromBytes` | Make an SSH multiple-precision integer from big-endian `bytes`.

DH_GENERATOR = (source)

Undocumented

DH_PRIME = (source)

Undocumented

DISCONNECT_AUTH_CANCELLED_BY_USER: `int` = (source)

Undocumented

Value

    13

DISCONNECT_BY_APPLICATION: `int` = (source)

Undocumented

Value

    11

DISCONNECT_COMPRESSION_ERROR: `int` = (source)

Undocumented

Value

    6

DISCONNECT_CONNECTION_LOST: `int` = (source)

Undocumented

Value

    10

DISCONNECT_HOST_KEY_NOT_VERIFIABLE: `int` = (source)

Undocumented

Value

    9

DISCONNECT_HOST_NOT_ALLOWED_TO_CONNECT: `int` = (source)

Undocumented

Value

    1

DISCONNECT_ILLEGAL_USER_NAME: `int` = (source)

Undocumented

Value

    15

DISCONNECT_KEY_EXCHANGE_FAILED: `int` = (source)

Undocumented

Value

    3

DISCONNECT_MAC_ERROR: `int` = (source)

Undocumented

Value

    5

DISCONNECT_NO_MORE_AUTH_METHODS_AVAILABLE: `int` = (source)

Undocumented

Value

    14

DISCONNECT_PROTOCOL_ERROR: `int` = (source)

Undocumented

Value

    2

DISCONNECT_PROTOCOL_VERSION_NOT_SUPPORTED: `int` = (source)

Undocumented

Value

    8

DISCONNECT_RESERVED: `int` = (source)

Undocumented

Value

    4

DISCONNECT_SERVICE_NOT_AVAILABLE: `int` = (source)

Undocumented

Value

    7

DISCONNECT_TOO_MANY_CONNECTIONS: `int` = (source)

Undocumented

Value

    12

MSG_DEBUG: `int` = (source)

Undocumented

Value

    4

MSG_DISCONNECT: `int` = (source)

Undocumented

Value

    1

MSG_EXT_INFO: `int` = (source)

Undocumented

Value

    7

MSG_IGNORE: `int` = (source)

Undocumented

Value

    2

MSG_KEX_DH_GEX_GROUP: `int` = (source)

Undocumented

Value

    31

MSG_KEX_DH_GEX_INIT: `int` = (source)

Undocumented

Value

    32

MSG_KEX_DH_GEX_REPLY: `int` = (source)

Undocumented

Value

    33

MSG_KEX_DH_GEX_REQUEST: `int` = (source)

Undocumented

Value

    34

MSG_KEX_DH_GEX_REQUEST_OLD: `int` = (source)

Undocumented

Value

    30

MSG_KEXDH_INIT: `int` = (source)

Undocumented

Value

    30

MSG_KEXDH_REPLY: `int` = (source)

Undocumented

Value

    31

MSG_KEXINIT: `int` = (source)

Undocumented

Value

    20

MSG_NEWKEYS: `int` = (source)

Undocumented

Value

    21

MSG_SERVICE_ACCEPT: `int` = (source)

Undocumented

Value

    6

MSG_SERVICE_REQUEST: `int` = (source)

Undocumented

Value

    5

MSG_UNIMPLEMENTED: `int` = (source)

Undocumented

Value

    3

messages: `dict` = (source)

Undocumented

def _getSupportedCiphers(): (source)
Build a list of ciphers that are supported by the backend in use.

Returns
`list` of `str` | a list of supported ciphers.

def _mpFromBytes(data): (source)

Make an SSH multiple-precision integer from big-endian `bytes`.

Used in ECDH key exchange.

Parameters
data:`bytes` | The input data, interpreted as a big-endian octet string.
Returns
`bytes` | The given data encoded as an SSH multiple-precision integer.